/* tr_lnext - find the successor of node pn
 * Returned value is ptr to link-in of successor node
 * Never returns NULL; may return addr of a null ptr
 */
#include "tree.h"
static TR_NODE *nullp = NULL;	/* used to return addr of null ptr */
TR_NODE **tr_lnext(plt, pn, cmpfn)
	TR_NODE **plt;			/* ptr to link-in of tree */
	TR_NODE *pn;			/* ptr to specific node of tree */
	int (*cmpfn)();			/* ptr to comparison function */
	{
	TR_NODE **pls;			/* ptr to link-in of successor */
	TR_NODE **pln;			/* ptr to link-in of a TR_NODE */

	if (pn->right != NULL)	/* if node has a right subtree, */
		{ /* return ptr to link-in of "leftmost"  node in right subtree */
		return (TR_LFIRST(&pn->right));
		}
	else						/* if node has no right subtree, */
		{		/* return ptr to link-in of parent of pn */
		pln = TR_LPFIND(plt, pn, cmpfn);
		if (*pln != NULL && (*pln)->left == pn)
			return (pln);		/* node is left subtree of parent */
		else
			return (&nullp);	/* node is rightmost in tree */
		}
	}
